<?php

namespace Drupal\flexible_access\EventSubscriber;

use Symfony\Component\EventDispatcher\EventSubscriberInterface;
use Symfony\Component\HttpKernel\Event\RequestEvent;
use Symfony\Component\HttpKernel\KernelEvents;
use Drupal\Core\Routing\RouteMatchInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Access\AccessResult;
use Symfony\Component\Routing\Route;

class NodeRouteSubscriber implements EventSubscriberInterface {
  public static function getSubscribedEvents() {
    return [
      KernelEvents::REQUEST => ['bypassGroupAccess', 30],
    ];
  }

  public function bypassGroupAccess(RequestEvent $event) {
    $request = $event->getRequest();
    $route_name = $request->attributes->get('_route');

    // Allow access only for specific routes (e.g., viewing nodes).
    if ($route_name === 'entity.node.canonical') {
      $request->attributes->set('_custom_access', 'flexible_access_check');
    }
  }
}
