<?php

namespace Drupal\flexible_access\Plugin\FlexibleAccessItem;

use Drupal\Core\Access\AccessResult;
use Drupal\Core\Access\AccessResultInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Entity\EntityInterface;
use Drupal\flexible_access\Plugin\FlexibleAccessItemBase;

/**
 * Provides a 'DefaultPublic' flexible access item.
 *
 * @FlexibleAccessItem(
 *   id = "public",
 *   label = @Translation("Public"),
 * )
 */
class DefaultPublic extends FlexibleAccessItemBase {

  /**
   * {@inheritdoc}
   */
  public function getAccessResult(AccountInterface $account, EntityInterface $entity): AccessResultInterface {
    return AccessResult::allowed();
  }

  /**
   * {@inheritdoc}
   */
  public function getIcon(): string {
    return '<span class="flexible-access-item-icon"><svg xmlns="http://www.w3.org/2000/svg"><path d="M12.015 7c4.751 0 8.063 3.012 9.504 4.636-1.401 1.837-4.713 5.364-9.504 5.364-4.42 0-7.93-3.536-9.478-5.407 1.493-1.647 4.817-4.593 9.478-4.593zm0-2c-7.569 0-12.015 6.551-12.015 6.551s4.835 7.449 12.015 7.449c7.733 0 11.985-7.449 11.985-7.449s-4.291-6.551-11.985-6.551zm-.015 3c-2.21 0-4 1.791-4 4s1.79 4 4 4c2.209 0 4-1.791 4-4s-1.791-4-4-4zm-.004 3.999c-.564.564-1.479.564-2.044 0s-.565-1.48 0-2.044c.564-.564 1.479-.564 2.044 0s.565 1.479 0 2.044z"/></svg></span>';
  }  

}
