<?php

namespace Drupal\flexible_access\Plugin;

use Drupal\Component\Plugin\PluginInspectionInterface;
use Drupal\Core\Session\AccountInterface;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Access\AccessResult;
use Drupal\Core\Access\AccessResultInterface;

/**
 * Defines an interface for FlexibleAccessItem plugins.
 */
interface FlexibleAccessItemInterface extends PluginInspectionInterface {

  /**
   * Returns an Access result for the given account and entity.
   *
   * @param \Drupal\Core\Session\AccountInterface $account
   *   The account.
   * 
   * @param \Drupal\Core\Entity\EntityInterface $entity
   *  The entity.
   *
   * @return \Drupal\Core\Access\AccessResult
   *   The access result.
   */
  public function getAccessResult(AccountInterface $account, EntityInterface $entity): AccessResultInterface;

  /**
   * Returns icon for the flexible access item.
   */
  public function getIcon();  


}
